#include <SoftwareSerial.h> //line to sensor board
#include <Stepper.h>

#define stepsperrevolution 2048
#define stepangle stepsperrevolution/360

#define stepper1 3
#define stepper2 2
#define stepper3 1
#define stepper4 0

SoftwareSerial port2(6 , 7);
Stepper stepper(stepsperrevolution, stepper1,stepper3,stepper2, stepper4);

#define rx 4
#define tx 5

#define sensorrx 6
#define ssplaceholder 7




int indata[8];
int outdata [28];
int stepperangle;

void setup() {
stepper.setSpeed(10);
Serial.begin(9600);
Serial.setTimeout(10000);
port2.begin(1200);

}

void loop() {


}



void serialEvent(){
   Serial.readStringUntil('<');
 String input = Serial.readStringUntil('>');
// Serial.println(input);
 if(input.substring(0,1)!="a"){input="";return;}
 else{input.remove(0,1);}
 int pointer = 0;
 for(int i = 0; i < input.length(); i++){
  int n = 1;
  if(input.substring(i,i+1) != ","){
    if(input.substring(i,i+1) == ">"){break;}
    while(input.substring(i+n-1,i+n) != "," && input.substring(i+n-1,i+n) != ">"){n++;}
    n--;
    indata[pointer] = input.substring(i,i+n).toInt();
    pointer++;
  }
  i+= n-1;
 }
 interpretaction();
}

void interpretaction(){
  if(indata[2] == 2){
    if(indata[0] == 9){
      scan();
    }
  }
  
  else{
    return;
  }
}

void scan()
{ 
  int pointer = 0;
  for(int i = 0; i < 360; i += 30){
  stepper.step(30*stepangle);
  stepperangle += 30;
  port2.listen();
  int distance = port2.parseInt();
  outdata[i/30] = distance;
  }

}

void senddata(){
  String message = "<a6,";
  for(int i = 0; i < 12; i++){
    message += outdata[i];
    outdata[i] = 0;
    message += ",";
  }
  message += ">";
  Serial.println(message);
}
