#include <SoftwareSerial.h>
#include <Stepper.h>

#define stepsperrevolution 2048
#define stepangle stepsperrevolution / 360

#define stepper11 2
#define stepper12 8
#define stepper13 7
#define stepper14 4

Stepper stepper1(stepsperrevolution, stepper11, stepper13, stepper12, stepper14);

#define stepper21 11
#define stepper22 12
#define stepper23 10
#define stepper24 13

Stepper stepper2(stepsperrevolution, stepper21, stepper23, stepper22, stepper24);



#define sserial 5
#define sserial2 6



#define wheeldiam 70 //mm



#define spd1 140 //left



float carposx = 0;
float carposy = 0;
float cardeltax = 0;
float cardeltay = 0;
float carangle = 0;
int stepperangle = 0;
bool stepperdir; //false left true right

int indata[28];


int outdata[12][2];

void setup() {
  
 stepper1.setSpeed(10);
 stepper2.setSpeed(10);
 Serial.begin(9600);
 
 Serial.setTimeout(10000);


}


void loop() {

}
/*
>1,1,1,1,1<
<1,2.1,2.1,2.>
SOLUTION TO INTERFERENCE BETWEEN DESTINATIONS:
  1. SWITCH ONLY FOR ARDUINO INTENDED MESSAGES BEGINNING AND END STRING BRACKETS
    PROCESSING INTENDED MESSAGES WOULD BE CLEARED OUT OF SERIAL BUFFER, VICE VERSA
  2. HAVE AN END CHARACTED FOR PROCESSING INTENDED MESSAGES, STRING ENDS WITH p> or a>, LOGIC
     USED TO DETERMINE DESTINATION
2 IS PROBABLY BEST
myString.endsWith(myString2) or myString[n-1] or myString.charAt(n-1)
myString.remove(index, count)
      String greeting = "hello";
      greeting.remove(2, 2);  // greeting now contains "heo"
        with string.length
*/
/*
message = "<" + "a" + "9" + "," + "0" + "," +  "2" + "," + ">";
     message =  "<" + "a" + "3" + "," + angle + "," + "1" + "," + ">";
     print(message);
   port.write(message);
   }
   else if(type == 4){
   message = "<" + "a" + "4" + "," + angle + "," + "1" + "," + ">";
   port.write(message);
   print(message);
   }
   else if(type == 1){
   message = "<" + "a" + "1" + "," + distance + "," + "1" + "," + ">";
   port.write(message);
   print(mexssage);
   }
   else if(type == 2){
   message = "<" + "a" + "2" + "," + distance + "," + "1" + "," + ">";
   port.write(message);
   print(message);

   <a9,0,> scan
   <a4,angle,> move 
   <a,3,angle>
   <a,1,distance,> move
   <a,2,distance,> move
*/
void serialEvent() {
 Serial.readStringUntil('<');
 String input = Serial.readStringUntil('>');
// Serial.println(input);
if(input.substring(0,1)!="a"){input = ""; return;}
 else{input.remove(0,1);}
 int pointer = 0;
 for(int i = 0; i < input.length(); i++){
  int n = 1;
  if(input.substring(i,i+1) != ","){
    if(input.substring(i,i+1) == ">"){break;}
    while(input.substring(i+n-1,i+n) != "," && input.substring(i+n-1,i+n) != ">"){n++;}
    n--;
    indata[pointer] = input.substring(i,i+n).toInt();
    pointer++;
  }
  i+= n-1;
 }

/* for(int i = 0; i < sizeof(indata)/sizeof(indata[0]); i++){
  Serial.println(indata[i]);
 }
*/
 domove();
}
void moveStraight(int distance, bool dir)
{

 if(dir)
  {
 stepper1.step(distance/22*stepsperrevolution);
 stepper2.step(distance/22*stepsperrevolution);
  }
 else
  {
 stepper1.step(-distance/22*stepsperrevolution);
 stepper2.step(-distance/22*stepsperrevolution);
  }

   
   cardeltax = cos(3.1415/180*(carangle))*distance;
   cardeltay = sin(3.1415/180*(carangle))*distance;
   carposx += cardeltax;
   carposy += cardeltay;
}

void moveAngle(int angle, bool dir)
{
  int dur = 100*round(angle);
  Serial.print(dur);
   if(dir)
  {
  stepper1.step(1/2*angle);
  stepper2.step(-1/2*angle);
  }
 else
  {
  stepper1.step(-1/2*angle);
  stepper2.step(1/2*angle);
  }
   if(dir){
  carangle += angle;
   }
   else{carangle -= angle;}
}

void mappoints(){
 for(int i = 0; i < 12; i++){
  int ptx = cos(carangle+i*30)*indata[i+1];
  int pty = sin(carangle+i*30)*indata[i+1];
  outdata[i][0] = ptx;
  outdata[i][1] = pty;
 }
 for(int i = 0; i < 28; i++){
  indata[i] == 0;
 }
}

void sendpoints()
{
  String outstring = "<7,";
 for(int i = 0; i < sizeof(outdata) / sizeof(outdata[0]); i++){
  outstring += outdata[i][0];
  outstring += ",";
  outstring += outdata[i][1];
  outstring += ",";
 }
 outstring += ">";
 Serial.println(outstring);
}



void domove()
{
  
 if(indata[0] == 1){
  moveStraight(indata[1],false);
 }
  else if(indata[0] == 2){
  moveStraight(indata[1],true);
  }
  else if(indata[0] == 3){
  moveAngle(indata[1],false);
  }
  else if(indata[0] == 4){
  moveAngle(indata[1],true);
  }
  else if(indata[0] == 6){
    
   mappoints();
   sendpoints();
  }
//  else if(indata[0] == 9){
//  scan();
//  sendpoints();
  }
